# $Id: __init__.py,v 1.7 2010/12/10 09:04:18 irees Exp $

import os
import subprocess
import getpass

from . import emen2proxy
import emen2.clients.proxy
import emen2.clients.handlers
import emen2.clients.controllers

# Setup some global variables.
# Default EMEN2URI is at the NCMI, but this can easily be set via the environment variable EMEN2URI
__version__ = "$Revision: 1.7 $".split(":")[1][:-1].strip()
USER_AGENT = "emen2client/%s"%__version__
EMEN2URI = os.getenv("EMEN2URI", "http://ncmidb.bcm.edu")


##################################
# Exported utility methods
##################################


# Run a process, get the standard out
def check_output(args, **kwds):
	kwds.setdefault("stdout", subprocess.PIPE)
	kwds.setdefault("stderr", subprocess.STDOUT)
	p = subprocess.Popen(args, **kwds)
	return p.communicate()[0]




def opendb(host=None, username=None, password=None, json=False):
	host = host or EMEN2URI
	username = username or raw_input("Username: ")
	password = password or getpass.getpass("Password: ")
	if json:
		db = emen2.clients.proxy.DBJSONRPCProxy(host=host)
	else:
		db = emen2.clients.proxy.DBXMLRPCProxy(host=host)
	db._login(username=username, password=password)
	return db



